<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <gz-extensions
      ref="extensions"
      :aya-type="sockType"
      :selected-items="selectedItems"
    >
    </gz-extensions>
    <gz-data-table
      ref="gzdatatable"
      form-key="vendor-list"
      data-list-key="VendorDataList"
      :show-select="rights.read"
      :reload="reload"
      data-cy="vendorsTable"
      :client-criteria="clientCriteria"
      :pre-filter-mode="preFilterMode"
      @selection-change="handleSelected"
      @clear-pre-filter="clearPreFilter"
    >
    </gz-data-table>
  </div>
</template>

<script>
const FORM_KEY = "vendor-list";
export default {
  data() {
    return {
      rights: window.$gz.role.defaultRightsObject(),
      sockType: window.$gz.type.Vendor,
      selectedItems: [],
      reload: false,
      clientCriteria: undefined,
      preFilterMode: null
    };
  },
  created() {
    this.rights = window.$gz.role.getRights(window.$gz.type.Vendor);
    window.$gz.eventBus.$on("menu-click", clickHandler);

    //------ pre-filter ----
    //OPTIONAL "Show All vendors of head office" FILTER
    this.objectId = window.$gz.util.stringToIntOrNull(
      this.$route.params.objectId
    );
    this.aForType = window.$gz.util.stringToIntOrNull(
      this.$route.params.sockType
    );

    if (this.objectId && this.objectId != 0 && this.aForType) {
      //OBJECTID,AYsockType
      this.clientCriteria = `${this.objectId},${this.aForType}`;

      this.preFilterMode = {
        icon: window.$gz.util.iconForType(this.aForType),
        id: this.objectId,
        socktype: this.aForType,
        viz: this.$route.params.name,
        clearable: true
      };
    }
    //------ /pre-filter ----
    generateMenu(this);
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    handleSelected(selected) {
      this.selectedItems = selected;
    },
    clearPreFilter() {
      this.clientCriteria = null;
      this.preFilterMode = null;
      this.reload = !this.reload;
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "new":
        m.vm.$router.push({
          name: "vendor-edit",
          params: { recordid: 0 }
        });
        break;
      case "extensions":
        {
          const res = await m.vm.$refs.extensions.open(
            m.vm.$refs.gzdatatable.getDataListSelection(window.$gz.type.Vendor)
          );
          if (res && res.refresh == true) {
            m.vm.reload = !m.vm.reload;
          }
        }
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            m.vm.$refs.gzdatatable.getDataListSelection(window.$gz.type.Vendor),
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: true,
    icon: "$sockiStore",
    title: "VendorList",
    menuItems: [],
    formData: {
      sockType: window.$gz.type.Vendor
    }
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$sockiPlus",
      surface: true,
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$sockiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$sockiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Extensions",
    icon: "$sockiPuzzlePiece",
    key: FORM_KEY + ":extensions",
    vm: vm
  });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
</script>
